## aspectc++ 2.2+git20170823

=== Ag++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************


# PUMA root
PUMA    ?= ../Puma

# default target
TARGET  ?= linux-release

#AspectC++ source directory
AC_SRC_DIR := ../AspectC++

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

# determine which Puma library to use: libMiniPuma is preferred
PUMA_LIBS := $(notdir $(wildcard $(PUMA)/lib/$(TARGET)/lib*Puma.a))
ifneq ($(filter libMiniPuma.a, $(PUMA_LIBS)),)
	PUMA_LIB := MiniPuma
else
	PUMA_LIB := Puma
endif

#CXX  := /usr/bin/g++-3.3
#CXX := ag++  -p. -p../aspects --Xcompiler
#CXX := ag++ -v3 -p. --Xcompiler

# compiler settings
ifeq ($(_TARGET),win32)
        CXXFLAGS += -I $(PUMA)/src/win32/regex
	EXT :=.exe
	RES := mingw32-windres
endif

CXXFLAGS += $(CPPFLAGS) -I$(PUMA)/extern -I$(PUMA)/include
ifneq ($(_TARGET),macosx_x86_64)
	ifeq ($(SHARED),)
		LDFLAGS += -static
	endif

LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -l$(PUMA_LIB)

ifneq ($(SHARED),)
LDFLAGS += -Wl,-Bdynamic
endif

else
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -l$(PUMA_LIB)
endif

ifneq ($(PROFILING),)
	LDFLAGS += -lc_p -lm_p 
	CXXFLAGS += -pg
endif

# ******************************
# *       S O U R C E S        *
# ******************************

BINBASE := bin
BINDIR := $(BINBASE)/$(TARGET)
PROG := $(BINDIR)/ag++$(EXT)

CCSOURCES := $(wildcard *.cc) 

OBJECTBASE := ObjFiles
OBJECTDIR := $(OBJECTBASE)/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:%.cc=%.o))

DEPBASE := DepFiles
DEPDIR := $(DEPBASE)/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:%.cc=%.d))

ifeq ($(_TARGET),win32)
RCFILES := win-ag++.rc
OBJECTS += $(addprefix $(OBJECTDIR)/,$(RCFILES:%.rc=%.o))
DEPS += $(addprefix $(DEPDIR)/,$(RCFILES:%.rc=%.d))
endif


DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)



# ******************************
# *     T A R G E T S          *
# ******************************

all: showtarget $(AC_SRC_DIR)/$(PROG)

strip: $(AC_SRC_DIR)/$(PROG)
	@$(STRIP) $<

showtarget:
	@echo "---"
	@echo "Making Ag++ for TARGET=$(TARGET)"
	@echo "  AC++     = $(ACXX) $(ACXXFLAGS) <objects> "
	@echo "  Compiler = $(CXX) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"

help: showtarget
	@echo 
	@echo 
	@echo "Make:" 
	@echo "  help:          show this help"
	@echo "  all (default): compile, link and copy"
	@echo "  copy:          copy executable into AspectC++ bin folder"
	@echo "  test :         run tests"
	@echo "  test_<XX>:     run test number <XX>"
	@echo "  clean:         remove intermediate files of current TARGET"
	@echo "  distclean:     clean all generated files and directories"
	@echo "---"

clean: 
	@echo -n "CLEAN    "
	rm -rf $(PROG) core core.*  $(DIRS)

distclean:
	rm -rf $(DEPBASE) $(OBJECTBASE) $(BINBASE)
 

test:	all
	@export TARGET=$(TARGET);export _TARGET=$(_TARGET);export EXT=$(EXT);cd tests;./run_tests.sh

test_%: all
	@export TARGET=$(TARGET);export _TARGET=$(_TARGET);export EXT=$(EXT);cd tests; ./run_tests.sh $@


.PHONY: all clean distclean showtarget

# ******************************
# *       R U L E S            *
# ******************************

$(PROG): $(OBJECTS)
	@echo "LD        $@"
	@mkdir -p $(BINDIR)
	@$(CXX) -o $@ $^ $(LDFLAGS)

$(AC_SRC_DIR)/$(PROG): $(PROG)
	@echo "COPY      $< to $@"
	@mkdir -p $(AC_SRC_DIR)/bin/$(TARGET)
	@cp $< $@

$(OBJECTDIR)/%.o : %.cc
	@echo "DEP       $(DEPDIR)/$(<:%.cc=%.d)."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CXXFLAGS) -MM -MP -MT $@ -MT $(DEPDIR)/$(<:%.cc=%.d) -MF $(DEPDIR)/$(<:%.cc=%.d) $< 
	@echo "CC        $@"
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CXXFLAGS) -c -o $@ $<

ifeq ($(_TARGET),win32)
$(OBJECTDIR)/%.o : %.rc
	@echo "DEP       $@."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CXXFLAGS) -MM -MP -MT $@ -MT $(DEPDIR)/$(<:%.cc=%.d) -MF $(DEPDIR)/$(<:%.cc=%.d) -xc++ $< 
	@echo "RES       $@"
	@mkdir -p $(OBJECTDIR)
	@$(RES) $(filter -D%,$(CXXFLAGS)) $< $@
endif

ifeq (,$(findstring clean,$(MAKECMDGOALS)))
ifeq (,$(findstring help,$(MAKECMDGOALS)))
-include $(DEPS)
endif
endif

.SUFFIXES: .cc .o .h .rc .mk $(SUFFIXES)

=== AspectC++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# AspectC++ supports alternative frontends: Puma or Clang
# It can be configured the 'make FRONTEND=...'. Default is Clang.
export FRONTEND ?= Clang

# PUMA root
PUMA    ?= ../Puma

# LLVM config command
LLVMCONF ?= llvm-config

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

# check whether we compile for Windows: TARGET-Variable starts with 'win'
ifneq ($(filter win%,$(TARGET)),)
	WIN := yes
	EXT := .exe
endif

# libxml2 settings
LIBXML2_INC := `xml2-config --cflags` 
LIBXML2_LIB := `xml2-config --libs` 

# Check Clang version and define all necessary symbols (LLVM_*)
ifneq ($(MAKECMDGOALS),clean)
  ifeq ($(FRONTEND),Clang)
    include config/clang.mk
  endif
endif

# linker settings
ifneq ($(_TARGET),macosx_x86_64)
ifeq ($(SHARED),)
  LDFLAGS += -static
endif
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -lPuma 
ifneq ($(SHARED),)
	LDFLAGS += -Wl,-Bdynamic
endif
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma 
ifneq ($(SHARED),)
	LDFLAGS += #-Wl,-Bdynamic
endif
endif
else
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lPuma
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma
endif
endif

LDFLAGS += $(LIBXML2_LIB)
ifneq ($(FRONTEND),Puma)
ifneq ($(_TARGET),macosx_x86_64)
  LDFLAGS += -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangSema -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
  LDFLAGS += $(patsubst %,-Xlinker --wrap=%,$(LLVM_SYMBOLS))
else
# Mac OS X is special, we patch the clang libraries below.
  LDFLAGS += libclangSema.o libclangLex.o -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangAnalysis -lclangEdit -lclangAST -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
endif
LDFLAGS += `$(LLVMCONF) --ldflags`
ifeq ($(filter 3.9%, $(LLVM_VERSION))$(filter 4.0%, $(LLVM_VERSION))$(filter 5.0%, $(LLVM_VERSION)),)
# if clang < 3.9:
LDFLAGS += `$(LLVMCONF) --system-libs` # in 3.6 ldflags doesn't contain the system libs anymore
else
# if clang >= 3.9:
# - Additional libraries ("--libs") needed
# - Starting with 4.0 "--system-libs" returns nothing if the debian clang package is used. "--link-static" forces
#   "--system-libs" to return the system libs in all cases
LDFLAGS += `$(LLVMCONF) --libs --system-libs --link-static`
endif
endif

# compiler settings
ifeq ($(WIN),yes)
	RES := windres
	RCFILES := win-ac++.rc
endif

CPPFLAGS += -I$(PUMA)/extern -I$(PUMA)/include $(LIBXML2_INC)
ifeq ($(FRONTEND),Puma)
  CPPFLAGS += -DFRONTEND_PUMA
else
  FILTEROUT :=
ifeq ($(RELEASE),debug)
  # filter-out "-DNDEBUG" added by LLVMCONF, if LLVM is in built in release-mode
  FILTEROUT := -DNDEBUG
endif
  LLVM_CPPFLAGS := $(shell $(LLVMCONF) --cppflags)
  ifeq ($(WIN),yes)
    # llvm-config on Windows generates path name with '\' that mingw g++ can't handle properly
    LLVM_CPPFLAGS := $(subst \,/,$(LLVM_CPPFLAGS))
  endif
  CPPFLAGS += $(filter-out $(FILTEROUT),$(LLVM_CPPFLAGS))
  CPPFLAGS += -DFRONTEND_CLANG=$(LLVM_INTERFACE)
  CXXFLAGS += -fno-rtti -Wno-strict-aliasing # hide annoying warning in Clang header 
  CXXFLAGS += -std=gnu++11 # Clang uses C++11 features; "c++11" does not work -> WIN32 not defined on Windows!
endif

# profiling
ifneq ($(GPROF),)
	LDFLAGS := $(LDFLAGS) -lc_p -lm_p 
	CXXFLAGS += -pg
endif

ifneq ($(PROFILING),)
	CPPFLAGS += -DPROFILING
endif

# use libacmodel
LDFLAGS  += -LACModel/lib/$(TARGET) -lacmodel 


# ******************************
# *       S O U R C E S        *
# ******************************

BINDIR := bin/$(TARGET)

#programm to compile
PROG := $(BINDIR)/ac++$(EXT)

# sources; front-end specific files for the wrong frontend are filtered out
CCSOURCES := $(wildcard *.cc)
ifeq ($(FRONTEND),Puma)
CCSOURCES := $(filter-out Clang%.cc, $(CCSOURCES))
else
CCSOURCES := $(filter-out Puma%.cc, $(CCSOURCES))
endif

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o) $(RCFILES:.rc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))

CONFIGDIR := config

DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)

# ******************************
# *  E X A M P L E  / T E S T  *
# ******************************

# tool selection
export AC := $(shell pwd)/$(PROG)
MAKE ?= make

# ac++ settings for tests
ACFLAGS := -k -v 9

ACEXAMPLES = coverage helloworld modules profiling singleton threads


.PHONY: $(ACEXAMPLES) 


# ******************************
# *      T A R G E T S         *
# ******************************

all: libacmodel showtarget $(PROG)
#.NOTPARALLEL: all

strip: $(PROG)
	@$(STRIP) $<

showtarget:
	@echo "---"
	@echo "Making AspectC++ for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"


clean:  testclean exampleclean
	@echo Making it clean.
	@$(MAKE) -C ACModel clean
	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)

cleanall:	doxygen-clean clean

test: $(PROG)$(EXT) testall

example: $(PROG)$(EXT) $(addsuffix .example_make, $(ACEXAMPLES))

examplerun: example $(addsuffix .example_run, $(ACEXAMPLES))

exampleclean:
	@rm -rf examples/*-out
	@rm -rf examples/*.acp

doxygen:
	@echo "Making AspectC++ documentation with doxygen"
	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"

doxygen-clean:
	@rm -rf doc/doxygen

.PHONY: all test clean cleanall example examplerun exampleclean \
        showtarget doxygen doxygen-clean libacmodel

# ******************************
# *       R U L E S            *
# ******************************

$(DIRS) :
	@mkdir -p $@

libacmodel :
	@$(MAKE) -C ACModel

$(PROG): $(OBJECTS) | libacmodel
# For clang on macosx_x86_64 we create relinked objects with the patched symbols.
ifneq ($(FRONTEND),Puma)
ifeq ($(_TARGET),macosx_x86_64)
	@echo "Creating patched clang libraries ..."
	@$(LD) -r `$(LLVMCONF) --libdir`/libclangSema.a -o libclangSema.o -all_load \
          $(foreach SYM, $(LLVM_SYMBOLS_SEMA), -alias $(SYM) ___real$(SYM) -unexported_symbol $(SYM))
	@$(LD) -r `$(LLVMCONF) --libdir`/libclangLex.a -o libclangLex.o -all_load \
          $(foreach SYM, $(LLVM_SYMBOLS_LEX), -alias $(SYM) ___real$(SYM) -unexported_symbol $(SYM))
endif
endif
	@echo "Linking $@."
	@mkdir -p $(BINDIR)
	@$(CXX) -o $@ $(CXXFLAGS) $^ $(LDFLAGS)


$(OBJECTDIR)/%.o : %.cc
	@echo Making dependency file $(DEPDIR)/$(<:%.cc=%.d).
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM -MP -MT $(OBJECTDIR)/$(<:%.cc=%.o) -MT $(DEPDIR)/$(<:%.cc=%.d) $< > $(DEPDIR)/$(<:%.cc=%.d)
	@echo Making object file $@.
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

# -Wold-style-cast to find classic C casts "a = (A*)b;"

ifeq ($(WIN),yes)
$(OBJECTDIR)/%.o : %.rc
	@echo Compiling Windows resource file
	@mkdir -p $(OBJECTDIR)
	@$(RES) $(filter -D%,$(CPPFLAGS)) $< $@

endif

test%: 
	$(MAKE) -C tests -s  $*

%.example_make: %
	cd examples/$< ; \
	$(AC) $(ACFLAGS) -I. -p . -d ../$<-out \
	-r ../$<.acp ; \
	cp Makefile ../$<-out/Makefile; \
	cd ../$<-out; g++ -o $< *.cc -lpthread

%.example_run:	%.example_make
	@echo ""
	@echo ---- Running $* ----
	@cd examples/$*-out; `find . -type f -perm -700`

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

=== AspectC++/config/Makefile ===
#
# makefile for generating a config file for the installed Clang version
#

# ******************************
# *       S E T T I N G S      *
# ******************************

# check whether llvm-config is available
ifeq ($(shell which $(LLVMCONF)),)
  $(error LLVMCONF ($(LLVMCONF)) is not found)
endif

LLVM_VERSION := $(shell $(LLVMCONF) --version)

LLVM_LIBDIR  := $(shell $(LLVMCONF) --libdir)
ifeq ($(_TARGET),win_x86_64) # handle '\' in path name
  LLVM_LIBDIR := $(subst \,/,$(LLVM_LIBDIR))
endif
LLVM_LIBS :=  $(LLVM_LIBDIR)/libclang*.a
# These functions need to be wrapped: parameters omitted to be more version independent
LLVM_KEY_COUNT := 12
LLVM_KEYS := _ZN5clang4Sema31ActOnStartCXXMemberDeclarations \
             _ZN5clang4Sema33ActOnFinishCXXMemberSpecification \
             _ZN5clang4Sema25ActOnEndOfTranslationUnit \
             _ZN5clang4Sema19canSkipFunctionBody \
             _ZN5clang4Sema24ActOnCXXMemberDeclarator \
             _ZN5clang4Sema15ActOnDeclarator \
             _ZN5clang12Preprocessor3Lex \
             _ZN5clang12Preprocessor9PeekAhead \
             _ZN5clang4Sema19ActOnBaseSpecifiers \
             _ZN5clang4Sema8ActOnTag \
             _ZN5clang4Sema22ActOnStartNamespaceDef \
             _ZN5clang4Sema23ActOnStartOfFunctionDefEPNS_5ScopeERNS_10Declarator
ifeq ($(_TARGET),macosx_x86_64) # on macOS the symbols have an additional '_'
  LLVM_KEYS := $(patsubst %, _%, $(LLVM_KEYS))
endif

# command to generate LLVM_SYMBOLS (a recursive variable!)
LLVM_SYMBOLS_GEN = $(foreach LLVM_KEY, $(LLVM_KEYS), $(filter _%, $(shell nm --defined-only $(LLVM_LIBS) | grep "T $(LLVM_KEY)")))

# ******************************
# *       R U L E S            *
# ******************************

clang: clang-$(LLVM_VERSION).mk

# find the exact symbols using the keys in the clang libraries
clang-$(LLVM_VERSION).mk:
	@echo Generating config file for Clang $(LLVM_VERSION)
	@echo LLVM_SYMBOLS := $(LLVM_SYMBOLS_GEN) > $@

=== AspectC++/tests/Makefile ===
ifeq ($(REGRESSIONTEST),1)
MAKELEVEL := 1
endif

ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the AspectC++ source tree instead)
endif

SHELL=/bin/bash
DIFF=diff --strip-trailing-cr

ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
          Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
          ArrayMangling MatchExpr ConsDesAdvice NestedClassFuncAdvice \
          MacroCall CallAdvice CallOnRef TemplateExtCall Bug190 Bug191 Bug192 \
	  Order NonInlineIntros JPType PragmaOnce Bug207 \
	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
          VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp STLString \
	  CFlowCycle Bug368 Bug179 RightlessCalls Bug477 \
	  IntroInBase Bug267 Bug268 Bug271 MatchVirtual \
	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 Bug209 \
          MatchStatic Bug512 SliceJPAPI JPTL NamedPointcuts AspectPrivileges \
	  RepoInvalid RepoVersion Bug321 Bug484 Bug524 DisjointIds AspectOf \
	  MemberPointCut MatchScopeWithin \
	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
          VirtualPointcuts Bug580 MacroExpansion Bug768 Bug769 Bug770

ifeq ($(FRONTEND),Clang)
ACTESTS += DataFlowAnalysis
ACTESTS += CallBuiltinOperator MemberPointCut2
ACTESTS += SimpleGetAdvice SimpleSetAdvice CompoundGetSetAdvice FunctionEntity \
           SimpleRefAdvice SimpleAliasAccessMember SimpleGetSetFuncPtr \
           ArrayAccessAdvice MatchScope GetBaseDerived \
           Bug-Typenames DefaultArgs2 CallViaADN Bug574 GetConditional Bug576 \
           Bug567 Bug568 Bug548 Bug589 Bug594 Bug598 CallRef Float128Basic
ACTESTS += Attribute_basic Attribute_inMacro Attribute_removeAttrs
		   #Attribute_pointcuts Attribute_params Attribute_paramEvaluation \
		   #Attribute_paramsIntrospection Attribute_stringParam
endif

# disabled: UnsizedArray
# to be removed: NonInlineIntroInclude
# (uses deprecated introduction syntax massively)

ACMSGTESTS := RepoInvalid RepoVersion Bug570

ACNORUN := $(filter $(ACMSGTESTS), $(ACTESTS))

ACRUN   := $(filter-out $(ACNORUN), $(ACTESTS))

STDOUT_FILE := stdout.txt
STDERR_FILE := stderr.txt
ERROR_FILE :=  error.txt

# ***** The following is only used for the Akut testsystem (REGRESSIONTEST == 1) *****
# ====================================================================================
ifeq ($(REGRESSIONTEST),1)

define do_test_start
    @COUNT=0;PASS=0;FAIL=0;
endef

define do_test_weave
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(1)/feature.out; \
	exec 2> $(1)/feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cp $(1)/feature.err $(1)/feature.out; \
	rm $(1)/feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) diff-only; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_run
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $(1) diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_end
	echo -n "---EXECUTIVE SUMMARY: " ;\
	if [ $$FAIL -eq $$COUNT ]; then\
		echo FAIL \(all tests failed\) ;\
	elif [ $$FAIL -gt 0 ]; then \
		echo PARTLY \($$(( $$PASS * 100 / $$COUNT ))% tests passed as expected\); \
	else \
		echo PASS \(all tests passed\) ;\
	fi ;\
	echo ---START SUMMARY; \
	echo $$COUNT tests in this testcase; \
	echo $$PASS tests passed as expected; \
	echo $$FAIL tests did not pass as expected; \
	echo $$FAIL expected to pass but failed; \
	echo 0 expected to fail but passed; \
	echo ---END SUMMARY
endef

regression_test:
	$(call do_test_start) \
	$(foreach T, $(ACRUN), $(call do_test_run, $(T))) \
	$(foreach T, $(ACNORUN), $(call do_test_weave, $(T))) \
	$(call do_test_end)

endif

# ================================================================================
# ***** The above is only used for the Akut testsystem (REGRESSIONTEST == 1) *****


all: $(addsuffix .make, $(ACRUN)) $(addsuffix .weave, $(ACNORUN))
	@if [ -f $(ERROR_FILE) ];then \
		echo -e "\n\n"; \
		echo "+---------+"; \
		echo "|ERRORS:  |"; \
		echo "+---------+"; \
		cat $(ERROR_FILE); \
		rm -f $(STDOUT_FILE) $(STDERR_FILE) $(ERROR_FILE); \
		exit 1; \
	 else \
		echo -e "\n\n"; \
	 	echo "All tests OK"; \
	 	rm -f $(STDOUT_FILE) $(STDERR_FILE); \
	 fi;\

ref:  $(addsuffix .ref, $(ACTESTS))

refclean:
	rm */feature.ref

run: $(addsuffix .run, $(ACRUN))

clean: $(addsuffix .clean, $(ACTESTS))


%.weave: %
	@unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $</feature.out; \
	exec 2> $</feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cp $</feature.err $</feature.out; \
	rm $</feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< diff-only; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
		ERR_FLAG=D; \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;


%.make: %
	@exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $< diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;




%.ref: %
	$(MAKE) -s EXT="$(EXT)" -C $< ref; 

%.run:	%
	@echo Making and running test '$<'
	cd $< && $(MAKE) run

%.clean: %
	cd $< && $(MAKE) clean

.PHONY: all clean run ref

=== Puma/tests/Makefile ===
ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the Puma source tree instead)
endif

SHELL = /bin/bash
export PUMA_CONFIG ?= $(CONFIG)

# fixed bugs
FIXED = misc bug129 bug138 bug96 bug130 bug108 bug94 bug149 \
        bug164 bug153 bug166 bug156 bug180 bug182 bug320 bug344 \
        bug269 bug259 bug248 bug218 bug203 bug350 bug273 bug326 \
        bug332 bug340 bug339 bug337 bug345 bug346 bug137 bug328 \
        bug333 bug363 bug2 bug5 bug6

# open bugs
OPEN = bug100 bug10 bug102 bug187 bug249 bug5 bug145 \
       bug188 bug342 bug61 bug189 bug338 \
       bug325 bug347 bug232 \
       bug303 bug289 bug287 bug275 bug348 bug343 bug274 \
       bug264 bug258 bug220

STDOUT_FILE := stdout.txt
STDERR_FILE := stderr.txt
ERROR_FILE  := error.txt

all:
	@(\
	([ ! -e ../examples/parser/parser ] && echo "Release build of Puma/examples/parser required for testing!") || \
	$(MAKE) run "TESTS=$(FIXED)" \
	)

open:
	@(\
	([ ! -e ../examples/parser/parser ] && echo "Release build of Puma/examples/parser required for testing!") || \
	$(MAKE) run "TESTS=$(OPEN)" \
	)

run: $(addsuffix .parse, $(TESTS))
	@if [ -f $(ERROR_FILE) ];then \
		echo -e "\n\n"; \
		echo "+---------+"; \
		echo "|ERRORS:  |"; \
		echo "+---------+"; \
		cat $(ERROR_FILE); \
	 else \
		echo -e "\n\n"; \
	 	echo "All tests OK"; \
	 fi;\
	 rm -f $(STDOUT_FILE) $(STDERR_FILE) $(ERROR_FILE)

ref:  $(addsuffix .ref, $(TESTS))

refclean:
	@rm -f */parse.ref

outclean:
	@rm -f */parse.out

clean: $(addsuffix .clean, $(FIXED)) $(addsuffix .clean, $(OPEN))

%.parse: %
	@unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec >& $</parse.out; \
	$(MAKE) -s -C $< ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	diff $</parse.out $</parse.ref; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
		ERR_FLAG=D; \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;

%.ref: %
	@$(MAKE) -s EXT="$(EXT)" -C $< ref; 

%.clean: %
	@cd $< && $(MAKE) clean

.PHONY: all clean ref

=== AspectC++/tests/Bug427/Makefile ===
ACFLAGS ?= --introspection
include ../Makefile.generic

=== AspectC++/tests/RepoInvalid/Makefile ===
ACFLAGS := -r repo.inv
WEAVE_ERROR := 1
include ../Makefile.generic

=== Puma/examples/sync/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

PROG     := sync
ROOT     := $(shell pwd)/../..
TARGET   ?= linux-release

OBJDIR   := obj
DEPDIR   := dep
GENDIR   := gen
INCDIR   := $(ROOT)/include $(ROOT)/extern $(GENDIR)
LIBDIR   := $(ROOT)/lib/$(TARGET)

SOURCES  := $(wildcard *.cc) 
OBJECTS  := $(addprefix $(OBJDIR)/,$(SOURCES:.cc=.o))
DEPS     := $(addprefix $(DEPDIR)/,$(SOURCES:.cc=.d))

include $(ROOT)/vars.mk

CPPFLAGS += $(CXXFLAGS) $(addprefix -I,$(INCDIR))

#-------------------------------------------------
# rules
#-------------------------------------------------

all: showinfo $(PROG)

showinfo:
	@echo 
	@echo "---"
	@echo "Compiling $(PROG) for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"
	@echo 

$(PROG): $(OBJECTS)
	@echo "Linking $@..."
	export LD_LIBRARY_PATH=$(LIBDIR); \
	$(CXX) -o $@ $^ -L$(LIBDIR) $(CXXFLAGS) -Wl,-Bstatic -lPuma -Wl,-Bdynamic $(CPPFLAGS) 
#	$(CXX) -o $@ $^ -L$(LIBDIR) $(CXXFLAGS) -Wl,-Bdynamic -lPuma -Wl,-Bdynamic $(CPPFLAGS) 

clean:
	@echo "Making $(PROG) clean..."
	@rm -f $(PROG)
	@rm -rf $(DEPDIR) $(OBJDIR) $(GENDIR)

#-------------------------------------------------
# targets
#-------------------------------------------------

$(OBJDIR)/%.o : %.cc
	@echo "Compiling $(filter %.cc,$^)..."
	@mkdir -p $(OBJDIR)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -g -o $@ $(filter %.cc,$^)

$(DEPDIR)/%.d : %.cc
	@echo "Generating dependencies for $(filter %.cc,$^)..."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM $(filter %.cc,$^) | \
	sed -e "s/$*\.o/$(OBJDIR)\/& $(DEPDIR)\/$*.d/g" > $@

.PHONY: clean

#-------------------------------------------------
# includes
#-------------------------------------------------

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

=== Puma/tests/bug343/Makefile ===
CCPARSEROPTFLAGS=--real-instances --dump-instances
include ../Makefile.generic

=== Puma/tests/bug364/Makefile ===
CCPARSEROPTFLAGS=--gnu-int128
include ../Makefile.generic

=== debian/changelog ===
aspectc++ (1:2.2+git20170823-7) unstable; urgency=medium

  * Build depend on llvm-dev (Closes: #902220)
  * Add autopkgtest

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 25 Jun 2018 10:59:10 -0400

aspectc++ (1:2.2+git20170823-6) unstable; urgency=medium

  * Add patch to fix FTBFS with gcc-8 (Closes: #897709)

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 22 May 2018 09:31:45 -0400

aspectc++ (1:2.2+git20170823-5) unstable; urgency=medium

  * Fix typo that resulted in wrong CFLAGS during compilation

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 18 Apr 2018 19:14:12 -0400

aspectc++ (1:2.2+git20170823-4) unstable; urgency=medium

  * Fix compilation options for builds on armel and armhf

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 17 Apr 2018 20:59:46 -0400

aspectc++ (1:2.2+git20170823-3) unstable; urgency=medium

  * debian/control: Update Vcs fields to point to salsa
  * aspectc++ FTBFS on armel: decrease optimization levels like on armhf
    (Closes: #894620)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 15 Apr 2018 17:48:31 -0400

aspectc++ (1:2.2+git20170823-2) unstable; urgency=medium

  * Use the default system clang (Closes: #893404)
    - Build depend on libclang-dev, which is build from llvm-defaults
      and is bumped by the llvm maintainers to point to the default
      version of clang

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 19 Mar 2018 09:04:07 -0400

aspectc++ (1:2.2+git20170823-1) unstable; urgency=medium

  * New upstream release
  * Fixes compilation with gcc-7 (Closes: #853319)

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 22 Aug 2017 21:37:27 -0400

aspectc++ (1:2.2-1) experimental; urgency=medium

  [ Reinhard Tartler ]
  * Upload to debian/experimental

  [ Radovan Birdic ]
  * Compile aspectc++ with -fPIC on mipsen (Closes: #845535)

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 27 Mar 2017 20:31:11 -0400

=== debian/control ===
Source: aspectc++
Section: devel
Priority: optional
Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper (>= 9), libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-dev, libclang-dev
Build-Depends-Indep: doxygen, graphviz, gsfonts
Standards-Version: 4.0.0
Homepage: http://www.aspectc.org
Vcs-Git: https://salsa.debian.org/debian/aspectc
Vcs-Browser: https://salsa.debian.org/debian/aspectc

Package: aspectc++
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++
Description: aspect-oriented programming extension for C++
 AspectC++ supports Aspect-Oriented Programming with C++, by providing:
 .
  - an aspect language extension to C++.
  - an aspect weaver that does source-to-source translation.
 .
 AspectC++ provides for C++ similar features like its best known
 cousin, AspectJ, provides for Java.

Package: libpuma-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Suggests: libpuma-doc
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to facilitate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships a static copy of libPuma only.

Package: libpuma-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to facilitate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships doxygen generated documentation for Puma.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# disable parallelism inside this makefile (but not submakes)
.NOTPARALLEL:

# Support multiple makes at once
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS := 1
# on i386 and amd64, we query the system unless overriden by DEB_BUILD_OPTIONS
ifeq      ($(DEB_HOST_ARCH),i386)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
else ifeq ($(DEB_HOST_ARCH),amd64)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
endif
endif

# workaround for bug #701244 - aspectc++ supports __int128 by default
# only when woven on 64bits, which the upstream provided sources don't.
AC_OPTFLAGS = --gnu-int128
export AC_OPTFLAGS

# we seem to have locking issues on kFreeBSD. force single threaded
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
NUMJOBS := 1
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS := -O0 -g
else
	CFLAGS := -O2 -g
endif

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq  (,$(filter $(DEB_BUILD_ARCH),armel armhf))
# fatal: Caught standard exception: deque::_M_new_elements_at_back
	CFLAGS := -O1 -g
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
	CFLAGS += -fPIC
endif

export CFLAGS
PUMA_CONFIG=$(CURDIR)/puma.config

test-builds: build-arch-stamp
	Ag++/bin/linux-release/ag++ --gen_config
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	-$(MAKE) -C AspectC++ PUMA_CONFIG=$(PUMA_CONFIG) FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-4.0 SHARED=1 AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" REGRESSIONTEST=1 examples test
	PATH=$(CURDIR)/AspectC++/bin/linux-release:$(PATH) \
	$(MAKE) -C Ag++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test

endif

build: build-arch build-indep

build-arch: build-arch-stamp test-builds
build-arch-stamp:
	dh_testdir
	$(MAKE) -C Puma/ MINI=1        -j$(NUMJOBS) all
	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-4.0
	$(MAKE) -C Ag++/      SHARED=1 -j$(NUMJOBS) all
	# ok, now we have both an ac++ binary and ag++ binary now let's
	# weave Puma again in the copy
	$(MAKE) -C Puma clean
	$(MAKE) -C Puma all AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" -j$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
	# build manpages:
	docbook-to-man debian/ac++.1.sgml > ac++.1
	docbook-to-man debian/ag++.1.sgml > ag++.1
	# mark timestamp
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir
	$(MAKE) -C Puma doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	dh_clean build-*stamp binary-*stamp puma.config
	# cleaning up source directories:
	$(MAKE) -s -C Puma cleanall
	# The clang frontend adds additional tests that need cleaning
	# so far, no tests are excluded by using the Clang frontend
	$(MAKE) -s -C AspectC++ cleanall FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-4.0
	$(MAKE) -s -C Ag++ clean
	# remove leftovers from Upstream Makefiles
	rm -rf Puma/include
	rm -rf AspectC++/tests/RepoVersion/repo.use
	rm -rf Ag++/DepFiles Ag++/ObjFiles Ag++/bin Ag++/tests/test_11.config
	rm -rf AspectC++/DepFiles AspectC++/ObjFiles AspectC++/bin
	rm -rf AspectC++/tests/*/feature.out
	rm -rf AspectC++/tests/RepoVersion/feature.fil
	# remove generated manpages:
	rm -f ac++.1 ag++.1
	rm -rf AspectC++/bin
	rm -rf Puma.copy/
	# remove autopkgtest cruft
	rm -rf Ag++/tests/src/obj
	rm -rf Ag++/tests/src/test
	# standard cleaning:
	dh_clean

# Build architecture-independent files here.
binary-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep
	dh_installchangelogs
	dh_installdocs -p libpuma-doc Puma/doc/RefMan/html
	dh_installexamples -p libpuma-doc Puma/examples/*
	dh_compress -X.cc -X.map
	dh_fixperms
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_installchangelogs
	dh_installdocs
	dh_install -Xlicence_1_0.txt
	dh_installexamples -p aspectc++ AspectC++/examples/*
	find debian/aspectc++ -name Makefile -exec rm -v {} +
	find debian/libpuma-doc -name Makefile -exec rm -v {} +
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean binary-indep binary-arch binary

## aspectc++ 2.2+git20181008

=== AspectC++/Makefile ===
--- 
+++ 
@@ -70,7 +70,7 @@
   LDFLAGS += libclangSema.o libclangLex.o -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangAnalysis -lclangEdit -lclangAST -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
 endif
 LDFLAGS += `$(LLVMCONF) --ldflags`
-ifeq ($(filter 3.9%, $(LLVM_VERSION))$(filter 4.0%, $(LLVM_VERSION))$(filter 5.0%, $(LLVM_VERSION)),)
+ifeq ($(filter 3.9%, $(LLVM_VERSION))$(filter 4.0%, $(LLVM_VERSION))$(filter 5.0%, $(LLVM_VERSION))$(filter 6.0%, $(LLVM_VERSION)),)
 # if clang < 3.9:
 LDFLAGS += `$(LLVMCONF) --system-libs` # in 3.6 ldflags doesn't contain the system libs anymore
 else

=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 	  MemberPointCut MatchScopeWithin \
 	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
 	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
-          VirtualPointcuts Bug580 MacroExpansion Bug768 Bug769 Bug770
+          VirtualPointcuts Bug580 MacroExpansion Bug768 Bug769 Bug770 Bug772
 
 ifeq ($(FRONTEND),Clang)
 ACTESTS += DataFlowAnalysis

=== debian/changelog ===
aspectc++ (1:2.2+git20181008-2) unstable; urgency=medium

  * Avoid using __float128 types, fixes FTBFS on ppc64el

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 23 Oct 2018 08:08:17 -0400

aspectc++ (1:2.2+git20181008-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

  [ Reinhard Tartler ]
  * New Upstream version.
  * Fix building with and build against Clang 6.0 with gcc-8.
    (Closes: #902220)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 21 Oct 2018 10:05:31 -0400

aspectc++ (1:2.2+git20170823-8) unstable; urgency=medium

  * Revert "Build depend on llvm-dev (Closes: #902220)" (Closes: #906972)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 26 Aug 2018 10:17:28 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Reinhard Tartler <siretart@tauware.de>
-Build-Depends: debhelper (>= 9), libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-dev, libclang-dev
+Build-Depends: debhelper (>= 9), libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-6.0-dev, libclang-6.0-dev
 Build-Depends-Indep: doxygen, graphviz, gsfonts
 Standards-Version: 4.0.0
 Homepage: http://www.aspectc.org

=== debian/rules ===
--- 
+++ 
@@ -50,8 +50,9 @@
 
 test-builds: build-arch-stamp
 	Ag++/bin/linux-release/ag++ --gen_config
+	echo '-D "__cplusplus=199711L"' >> $(PUMA_CONFIG)
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	-$(MAKE) -C AspectC++ PUMA_CONFIG=$(PUMA_CONFIG) FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-4.0 SHARED=1 AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" REGRESSIONTEST=1 examples test
+	-$(MAKE) -C AspectC++ PUMA_CONFIG=$(PUMA_CONFIG) FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-6.0 SHARED=1 AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" REGRESSIONTEST=1 examples test
 	PATH=$(CURDIR)/AspectC++/bin/linux-release:$(PATH) \
 	$(MAKE) -C Ag++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
 
@@ -63,7 +64,7 @@
 build-arch-stamp:
 	dh_testdir
 	$(MAKE) -C Puma/ MINI=1        -j$(NUMJOBS) all
-	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-4.0
+	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-6.0
 	$(MAKE) -C Ag++/      SHARED=1 -j$(NUMJOBS) all
 	# ok, now we have both an ac++ binary and ag++ binary now let's
 	# weave Puma again in the copy
@@ -89,7 +90,7 @@
 	$(MAKE) -s -C Puma cleanall
 	# The clang frontend adds additional tests that need cleaning
 	# so far, no tests are excluded by using the Clang frontend
-	$(MAKE) -s -C AspectC++ cleanall FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-4.0
+	$(MAKE) -s -C AspectC++ cleanall FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-6.0
 	$(MAKE) -s -C Ag++ clean
 	# remove leftovers from Upstream Makefiles
 	rm -rf Puma/include

=== debian/tests/control ===
Tests: ag++_compile
Restrictions: rw-build-tree
